unit MainClient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, LoksimControl_TLB, StdCtrls, ExtCtrls, ComCtrls, LoksimUtils;

type
  TFormLoksimClient = class(TForm)
    Panel1: TPanel;
    ButtonStart: TButton;
    ButtonStartRemote: TButton;
    EditHost: TEdit;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    ButtonHauptSchalter: TButton;
    LabelHauptschalter: TLabel;
    Panel3: TPanel;
    LabelActKMH: TLabel;
    LabelActSimTime: TLabel;
    LabelVMax: TLabel;
    Panel4: TPanel;
    LabelSifa: TLabel;
    ButtonSifa: TButton;
    Panel5: TPanel;
    ButtonSchaltDown: TButton;
    Label1: TLabel;
    ButtonSchaltUp: TButton;
    LabelSchaltSoll: TLabel;
    LabelSchaltIst: TLabel;
    Panel6: TPanel;
    LabelAFBAn: TLabel;
    LabelAFBV: TLabel;
    ButtonAFBDown: TButton;
    ButtonAFBUp: TButton;
    Panel7: TPanel;
    Label5: TLabel;
    LabelHLDruck: TLabel;
    LabelZylDruck: TLabel;
    ButtonBremseDown: TButton;
    ButtonBremseUp: TButton;
    ButtonAFB: TButton;
    ButtonIndusi: TButton;
    procedure ButtonStartClick(Sender: TObject);
    procedure ButtonStartRemoteClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ButtonHauptSchalterClick(Sender: TObject);
    procedure ButtonSifaClick(Sender: TObject);
    procedure ButtonSchaltDownClick(Sender: TObject);
    procedure ButtonSchaltUpClick(Sender: TObject);
    procedure ButtonBremseDownClick(Sender: TObject);
    procedure ButtonBremseUpClick(Sender: TObject);
    procedure ButtonAFBClick(Sender: TObject);
    procedure ButtonAFBDownClick(Sender: TObject);
    procedure ButtonAFBUpClick(Sender: TObject);
    procedure ButtonIndusiClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Loksim: ILoksimAutoServer;
    FHauptSchalter: boolean;
    FActSpeed: Double;
    FLokMaxSpeed: Double;
    FActSimTime: Double;
    FAnzeigeSifa: boolean;
    FSchaltSoll: double;
    FSchaltIst: double;
    FHlDruck: double;
    FZylinderDruck: double;
    FAfbStatus: boolean;
    FAfbZiel: double;
  public
    { Public-Deklarationen }
  end;

var
  FormLoksimClient: TFormLoksimClient;

implementation

{$R *.dfm}

procedure TFormLoksimClient.ButtonStartClick(Sender: TObject);
begin
  Loksim := CoLoksimAutoServer.Create;
end;

procedure TFormLoksimClient.ButtonStartRemoteClick(Sender: TObject);
begin
  Loksim := CoLoksimAutoServer.CreateRemote( EditHost.Text);
end;

procedure TFormLoksimClient.Timer1Timer(Sender: TObject);
var
  Params: WideString;
  RetParams: WideString;
begin
  Timer1.Enabled := False;
  if Assigned( Loksim) then
  begin
    try
      Loksim.StartWaitForCommands( 500);
      if Loksim.LoksimIsRunning then
      begin
        if Loksim.SimulationIsRunning then
        begin
          StatusBar1.SimpleText := 'Alles ok';
          // Jetzt die Stati abfragen
          Params := '';
          LoksimUtilsAddParam( Params, cLOK_COMMON_ACTSPEED);
          LoksimUtilsAddParam( Params, cLOK_COMMON_MAXSPEED);
          LoksimUtilsAddParam( Params, cSIM_COMMON_SIMTIME);
          LoksimUtilsAddParam( Params, cLOK_ANZEIGE_HAUPTSCHALTER);
          LoksimUtilsAddParam( Params, cLOK_ANZEIGE_SIFA);
          LoksimUtilsAddParam( Params, cLOK_INSTRUMENT_SOLLSTUFE);
          LoksimUtilsAddParam( Params, cLOK_INSTRUMENT_ISTSTUFE);
          LoksimUtilsAddParam( Params, cLOK_INSTRUMENT_BREMSDRUCK);
          LoksimUtilsAddParam( Params, cLOK_INSTRUMENT_BREMSZYLINDERDRUCK);
          LoksimUtilsAddParam( Params, cLOK_ANZEIGE_AFB);
          LoksimUtilsAddParam( Params, cLOK_INSTRUMENT_AFB);


          RetParams := Loksim.GetSimData( Params);

          FActSpeed := LoksimUtilsGetParamFloat( RetParams, cLOK_COMMON_ACTSPEED);
          FLokMaxSpeed := LoksimUtilsGetParamFloat( RetParams, cLOK_COMMON_MAXSPEED);
          FActSimTime := LoksimUtilsGetParamFloat( RetParams, cSIM_COMMON_SIMTIME);

          FHauptSchalter := LoksimUtilsGetParamBool( RetParams, cLOK_ANZEIGE_HAUPTSCHALTER);
          FAnzeigeSifa := LoksimUtilsGetParamBool( RetParams, cLOK_ANZEIGE_SIFA);

          FSchaltSoll := LoksimUtilsGetParamFloat( RetParams, cLOK_INSTRUMENT_SOLLSTUFE);
          FSchaltIst := LoksimUtilsGetParamFloat( RetParams, cLOK_INSTRUMENT_ISTSTUFE);

          FHlDruck := LoksimUtilsGetParamFloat( RetParams, cLOK_INSTRUMENT_BREMSDRUCK);
          FZylinderDruck := LoksimUtilsGetParamFloat( RetParams, cLOK_INSTRUMENT_BREMSZYLINDERDRUCK);
          FAfbStatus := LoksimUtilsGetParamBool( RetParams, cLOK_ANZEIGE_AFB);
          FAfbZiel := LoksimUtilsGetParamFloat( RetParams, cLOK_INSTRUMENT_AFB);

        end
        else
        begin
          StatusBar1.SimpleText := 'Simulation luft nicht oder pausiert';
        end;
      end
      else
      begin
        StatusBar1.SimpleText := 'Loksim luft nicht -> Loksim starten';
      end;
    finally
      Loksim.StopWaitForCommands;
    end;
  end
  else
  begin
    StatusBar1.SimpleText := 'Ole-Server nicht gestartet -> Drcken sie Start';
  end;

  //und Controls setzten
  if FHauptSchalter then
    LabelHauptschalter.Caption := 'An'
  else
    LabelHauptschalter.Caption := 'Aus';

  LabelActKMH.Caption := 'V: ' + FloatToStr( FActSpeed);
  LabelVMax.Caption := 'Vmax: ' + FloatToStr( FLokMaxSpeed);
  LabelActSimTime.Caption := 'ActSimTime: ' + FloatToStr( FActSimTime);

  if FAnzeigeSifa then
    LabelSifa.Caption := 'Lampe AN'
  else
    LabelSifa.Caption := 'Lampe AUS';

  LabelSchaltSoll.Caption := 'Soll: ' + FloatToStr( FSchaltSoll);
  LabelSchaltIst.Caption := 'Ist: ' + FloatToStr( FSchaltIst);

  LabelHLDruck.Caption := 'HLDruck: ' + FloatToStr( FHlDruck);
  LabelZylDruck.Caption := 'Zyl.Druck: ' + FloatToStr( FZylinderDruck);

  if FAfbStatus then
    LabelAFBAn.Caption := 'AFB AN'
  else
    LabelAFBAn.Caption := 'AFB AUS';

  LabelAFBV.Caption := 'AFB-Ziel: ' + FloatToStr( FAfbZiel);

  Timer1.Enabled := True;  
end;

procedure TFormLoksimClient.ButtonHauptSchalterClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_HAUPTSCHALTER);
  end;
end;

procedure TFormLoksimClient.ButtonSifaClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_SIFA);
  end;
end;

procedure TFormLoksimClient.ButtonSchaltDownClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_STDOWN);
  end;
end;

procedure TFormLoksimClient.ButtonSchaltUpClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_STUP);
  end;
end;

procedure TFormLoksimClient.ButtonBremseDownClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_BREMSEN7);
  end;
end;

procedure TFormLoksimClient.ButtonBremseUpClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_BREMSEN1);
  end;
end;

procedure TFormLoksimClient.ButtonAFBClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_AFB);
  end;
end;

procedure TFormLoksimClient.ButtonAFBDownClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_STLEFT);
  end;
end;

procedure TFormLoksimClient.ButtonAFBUpClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_STRIGHT);
  end;
end;

procedure TFormLoksimClient.ButtonIndusiClick(Sender: TObject);
begin
  if Assigned( Loksim) then
  begin
    Loksim.SendKey( KEY_INDUSI);
  end;
end;

end.
