unit AutoServer;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, ActiveX, AxCtrls, Classes, LoksimControl_TLB, StdVcl, Main;

type
  TLoksimAutoServer = class(TAutoObject, IConnectionPointContainer, ILoksimAutoServer)
  private
    { Private-Deklarationen }
    FConnectionPoints: TConnectionPoints;
    FConnectionPoint: TConnectionPoint;
    FEvents: ILoksimAutoServerEvents;
    { Hinweis: FEvents unterhlt eine  *einzelne* Ereignissenke. Verwenden Sie 
      fr den Zugriff auf mehrere Ereignissenken FConnectionPoint.SinkList und
      durchlaufen Sie die Liste der Senken. }
  public
    procedure Initialize; override;
  protected
    { Protected-Deklarationen }
    property ConnectionPoints: TConnectionPoints read FConnectionPoints
      implements IConnectionPointContainer;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function LoksimIsRunning: WordBool; safecall;
    procedure StartWaitForCommands(TimeOut: Integer); safecall;
    procedure StopWaitForCommands; safecall;
    function SimulationIsRunning: WordBool; safecall;
    function GetSimData(const ParamStr: WideString): WideString; safecall;
    procedure SendKey(KeyIndex: SYSINT); safecall;
  end;

implementation

uses ComServ;

procedure TLoksimAutoServer.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as ILoksimAutoServerEvents;
end;

procedure TLoksimAutoServer.Initialize;
begin
  inherited Initialize;
  FConnectionPoints := TConnectionPoints.Create(Self);
  if AutoFactory.EventTypeInfo <> nil then
    FConnectionPoint := FConnectionPoints.CreateConnectionPoint(
      AutoFactory.EventIID, ckSingle, EventConnect)
  else FConnectionPoint := nil;
end;


function TLoksimAutoServer.LoksimIsRunning: WordBool;
begin
  Result := FormCommunication.LoksimIsRunning;
end;

procedure TLoksimAutoServer.StartWaitForCommands(TimeOut: Integer);
begin
  FormCommunication.StartWaitForCommands( TimeOut);
end;

procedure TLoksimAutoServer.StopWaitForCommands;
begin
  FormCommunication.StopWaitForCommands;
end;

function TLoksimAutoServer.SimulationIsRunning: WordBool;
begin
  Result := FormCommunication.SimulationIsRunning;
end;

function TLoksimAutoServer.GetSimData(
  const ParamStr: WideString): WideString;
begin
  Result := FormCommunication.GetSimData( ParamStr);
end;

procedure TLoksimAutoServer.SendKey(KeyIndex: SYSINT);
begin
  FormCommunication.SendKey( KeyIndex);
end;

initialization
  TAutoObjectFactory.Create(ComServer, TLoksimAutoServer, Class_LoksimAutoServer,
    ciSingleInstance, tmApartment);
end.
